
/* Python wrapper functions auto-generated by pidl */
#define PY_SSIZE_T_CLEAN 1 /* We use Py_ssize_t for PyArg_ParseTupleAndKeywords */
#include <Python.h>
#include "python/py3compat.h"
#include "includes.h"
#include <pytalloc.h>
#include "librpc/rpc/pyrpc.h"
#include "librpc/rpc/pyrpc_util.h"
#include "bin/default/librpc/gen_ndr/ndr_notify.h"
#include "bin/default/librpc/gen_ndr/ndr_notify_c.h"

/*
 * These functions are here to ensure they can be optimized out by
 * the compiler based on the constant input values
 */

static inline unsigned long long ndr_sizeof2uintmax(size_t var_size)
{
	switch (var_size) {
	case 8:
		return UINT64_MAX;
	case 4:
		return UINT32_MAX;
	case 2:
		return UINT16_MAX;
	case 1:
		return UINT8_MAX;
	}

	return 0;
}

static inline long long ndr_sizeof2intmax(size_t var_size)
{
	switch (var_size) {
	case 8:
		return INT64_MAX;
	case 4:
		return INT32_MAX;
	case 2:
		return INT16_MAX;
	case 1:
		return INT8_MAX;
	}

	return 0;
}

static inline PyObject *ndr_PyLong_FromLongLong(long long v)
{
	if (v > LONG_MAX || v < LONG_MIN) {
		return PyLong_FromLongLong(v);
	} else {
		return PyInt_FromLong(v);
	}
}

static inline PyObject *ndr_PyLong_FromUnsignedLongLong(unsigned long long v)
{
	if (v > LONG_MAX) {
		return PyLong_FromUnsignedLongLong(v);
	} else {
		return PyInt_FromLong(v);
	}
}

#include "librpc/gen_ndr/file_id.h"
#include "librpc/gen_ndr/server_id.h"
static PyTypeObject notify_entry_Type;
static PyTypeObject notify_entry_array_Type;
static PyTypeObject notify_db_entry_Type;
static PyTypeObject notify_depth_Type;
static PyTypeObject notify_array_Type;
static PyTypeObject notify_event_Type;
static PyTypeObject notify_remote_event_Type;
static PyTypeObject FILE_NOTIFY_INFORMATION_Type;

static PyTypeObject *server_id_Type;
static PyTypeObject *file_id_Type;
static PyTypeObject *BaseObject_Type;

static PyObject *py_notify_entry_get_server(PyObject *obj, void *closure)
{
	struct notify_entry *object = (struct notify_entry *)pytalloc_get_ptr(obj);
	PyObject *py_server;
	py_server = pytalloc_reference_ex(server_id_Type, pytalloc_get_mem_ctx(obj), &object->server);
	return py_server;
}

static int py_notify_entry_set_server(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_entry *object = (struct notify_entry *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->server");
		return -1;
	}
	PY_CHECK_TYPE(server_id_Type, value, return -1;);
	if (talloc_reference(pytalloc_get_mem_ctx(py_obj), pytalloc_get_mem_ctx(value)) == NULL) {
		PyErr_NoMemory();
		return -1;
	}
	object->server = *(struct server_id *)pytalloc_get_ptr(value);
	return 0;
}

static PyObject *py_notify_entry_get_filter(PyObject *obj, void *closure)
{
	struct notify_entry *object = (struct notify_entry *)pytalloc_get_ptr(obj);
	PyObject *py_filter;
	py_filter = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->filter);
	return py_filter;
}

static int py_notify_entry_set_filter(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_entry *object = (struct notify_entry *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->filter");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->filter));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->filter = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->filter = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_notify_entry_get_subdir_filter(PyObject *obj, void *closure)
{
	struct notify_entry *object = (struct notify_entry *)pytalloc_get_ptr(obj);
	PyObject *py_subdir_filter;
	py_subdir_filter = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->subdir_filter);
	return py_subdir_filter;
}

static int py_notify_entry_set_subdir_filter(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_entry *object = (struct notify_entry *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->subdir_filter");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->subdir_filter));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->subdir_filter = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->subdir_filter = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_notify_entry_get_dir_fd(PyObject *obj, void *closure)
{
	struct notify_entry *object = (struct notify_entry *)pytalloc_get_ptr(obj);
	PyObject *py_dir_fd;
	py_dir_fd = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->dir_fd);
	return py_dir_fd;
}

static int py_notify_entry_set_dir_fd(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_entry *object = (struct notify_entry *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->dir_fd");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->dir_fd));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->dir_fd = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->dir_fd = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_notify_entry_get_dir_id(PyObject *obj, void *closure)
{
	struct notify_entry *object = (struct notify_entry *)pytalloc_get_ptr(obj);
	PyObject *py_dir_id;
	py_dir_id = pytalloc_reference_ex(file_id_Type, pytalloc_get_mem_ctx(obj), &object->dir_id);
	return py_dir_id;
}

static int py_notify_entry_set_dir_id(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_entry *object = (struct notify_entry *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->dir_id");
		return -1;
	}
	PY_CHECK_TYPE(file_id_Type, value, return -1;);
	if (talloc_reference(pytalloc_get_mem_ctx(py_obj), pytalloc_get_mem_ctx(value)) == NULL) {
		PyErr_NoMemory();
		return -1;
	}
	object->dir_id = *(struct file_id *)pytalloc_get_ptr(value);
	return 0;
}

static PyObject *py_notify_entry_get_path(PyObject *obj, void *closure)
{
	struct notify_entry *object = (struct notify_entry *)pytalloc_get_ptr(obj);
	PyObject *py_path;
	py_path = PyString_FromStringOrNULL(object->path);
	return py_path;
}

static int py_notify_entry_set_path(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_entry *object = (struct notify_entry *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->path");
		return -1;
	}
	{
		const char *test_str;
		const char *talloc_str;
		PyObject *unicode = NULL;
		if (PyUnicode_Check(value)) {
			unicode = PyUnicode_AsEncodedString(value, "utf-8", "ignore");
			if (unicode == NULL) {
				PyErr_NoMemory();
				return -1;
			}
			test_str = PyBytes_AS_STRING(unicode);
		} else if (PyBytes_Check(value)) {
			test_str = PyBytes_AS_STRING(value);
		} else {
			PyErr_Format(PyExc_TypeError, "Expected string or unicode object, got %s", Py_TYPE(value)->tp_name);
			return -1;
		}
		talloc_str = talloc_strdup(pytalloc_get_mem_ctx(py_obj), test_str);
		if (unicode != NULL) {
			Py_DECREF(unicode);
		}
		if (talloc_str == NULL) {
			PyErr_NoMemory();
			return -1;
		}
		object->path = talloc_str;
	}
	return 0;
}

static PyObject *py_notify_entry_get_path_len(PyObject *obj, void *closure)
{
	struct notify_entry *object = (struct notify_entry *)pytalloc_get_ptr(obj);
	PyObject *py_path_len;
	py_path_len = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->path_len);
	return py_path_len;
}

static int py_notify_entry_set_path_len(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_entry *object = (struct notify_entry *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->path_len");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->path_len));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->path_len = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->path_len = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_notify_entry_get_private_data(PyObject *obj, void *closure)
{
	struct notify_entry *object = (struct notify_entry *)pytalloc_get_ptr(obj);
	PyObject *py_private_data;
	py_private_data = pytalloc_GenericObject_reference_ex(pytalloc_get_mem_ctx(obj), object->private_data);
	return py_private_data;
}

static int py_notify_entry_set_private_data(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_entry *object = (struct notify_entry *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->private_data");
		return -1;
	}
	object->private_data = pytalloc_get_ptr(value);
	return 0;
}

static PyGetSetDef py_notify_entry_getsetters[] = {
	{
		.name = discard_const_p(char, "server"),
		.get = py_notify_entry_get_server,
		.set = py_notify_entry_set_server,
		.doc = discard_const_p(char, "PIDL-generated element of base type server_id")
	},
	{
		.name = discard_const_p(char, "filter"),
		.get = py_notify_entry_get_filter,
		.set = py_notify_entry_set_filter,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint32")
	},
	{
		.name = discard_const_p(char, "subdir_filter"),
		.get = py_notify_entry_get_subdir_filter,
		.set = py_notify_entry_set_subdir_filter,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint32")
	},
	{
		.name = discard_const_p(char, "dir_fd"),
		.get = py_notify_entry_get_dir_fd,
		.set = py_notify_entry_set_dir_fd,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint32")
	},
	{
		.name = discard_const_p(char, "dir_id"),
		.get = py_notify_entry_get_dir_id,
		.set = py_notify_entry_set_dir_id,
		.doc = discard_const_p(char, "PIDL-generated element of base type file_id")
	},
	{
		.name = discard_const_p(char, "path"),
		.get = py_notify_entry_get_path,
		.set = py_notify_entry_set_path,
		.doc = discard_const_p(char, "PIDL-generated element of base type string")
	},
	{
		.name = discard_const_p(char, "path_len"),
		.get = py_notify_entry_get_path_len,
		.set = py_notify_entry_set_path_len,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint32")
	},
	{
		.name = discard_const_p(char, "private_data"),
		.get = py_notify_entry_get_private_data,
		.set = py_notify_entry_set_private_data,
		.doc = discard_const_p(char, "PIDL-generated element of base type pointer")
	},
	{ .name = NULL }
};

static PyObject *py_notify_entry_new(PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
	return pytalloc_new(struct notify_entry, type);
}

static PyObject *py_notify_entry_ndr_pack(PyObject *py_obj)
{
	struct notify_entry *object = (struct notify_entry *)pytalloc_get_ptr(py_obj);
	PyObject *ret = NULL;
	DATA_BLOB blob;
	enum ndr_err_code err;
	TALLOC_CTX *tmp_ctx = talloc_new(pytalloc_get_mem_ctx(py_obj));
	if (tmp_ctx == NULL) {
		PyErr_SetNdrError(NDR_ERR_ALLOC);
		return NULL;
	}
	err = ndr_push_struct_blob(&blob, tmp_ctx, object, (ndr_push_flags_fn_t)ndr_push_notify_entry);
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		TALLOC_FREE(tmp_ctx);
		PyErr_SetNdrError(err);
		return NULL;
	}

	ret = PyBytes_FromStringAndSize((char *)blob.data, blob.length);
	TALLOC_FREE(tmp_ctx);
	return ret;
}

static PyObject *py_notify_entry_ndr_unpack(PyObject *py_obj, PyObject *args, PyObject *kwargs)
{
	struct notify_entry *object = (struct notify_entry *)pytalloc_get_ptr(py_obj);
	DATA_BLOB blob;
	Py_ssize_t blob_length = 0;
	enum ndr_err_code err;
	const char * const kwnames[] = { "data_blob", "allow_remaining", NULL };
	PyObject *allow_remaining_obj = NULL;
	bool allow_remaining = false;

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, PYARG_BYTES_LEN "|O:__ndr_unpack__",
		discard_const_p(char *, kwnames),
		&blob.data, &blob_length,
		&allow_remaining_obj)) {
		return NULL;
	}
	blob.length = blob_length;

	if (allow_remaining_obj && PyObject_IsTrue(allow_remaining_obj)) {
		allow_remaining = true;
	}

	if (allow_remaining) {
		err = ndr_pull_struct_blob(&blob, pytalloc_get_mem_ctx(py_obj), object, (ndr_pull_flags_fn_t)ndr_pull_notify_entry);
	} else {
		err = ndr_pull_struct_blob_all(&blob, pytalloc_get_mem_ctx(py_obj), object, (ndr_pull_flags_fn_t)ndr_pull_notify_entry);
	}
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		PyErr_SetNdrError(err);
		return NULL;
	}

	Py_RETURN_NONE;
}

static PyObject *py_notify_entry_ndr_print(PyObject *py_obj)
{
	struct notify_entry *object = (struct notify_entry *)pytalloc_get_ptr(py_obj);
	PyObject *ret;
	char *retstr;

	retstr = ndr_print_struct_string(pytalloc_get_mem_ctx(py_obj), (ndr_print_fn_t)ndr_print_notify_entry, "notify_entry", object);
	ret = PyStr_FromString(retstr);
	talloc_free(retstr);

	return ret;
}

static PyMethodDef py_notify_entry_methods[] = {
	{ "__ndr_pack__", (PyCFunction)py_notify_entry_ndr_pack, METH_NOARGS, "S.ndr_pack(object) -> blob\nNDR pack" },
	{ "__ndr_unpack__", (PyCFunction)py_notify_entry_ndr_unpack, METH_VARARGS|METH_KEYWORDS, "S.ndr_unpack(class, blob, allow_remaining=False) -> None\nNDR unpack" },
	{ "__ndr_print__", (PyCFunction)py_notify_entry_ndr_print, METH_NOARGS, "S.ndr_print(object) -> None\nNDR print" },
	{ NULL, NULL, 0, NULL }
};


static PyTypeObject notify_entry_Type = {
	PyVarObject_HEAD_INIT(NULL, 0)
	.tp_name = "notify.entry",
	.tp_getset = py_notify_entry_getsetters,
	.tp_methods = py_notify_entry_methods,
	.tp_flags = Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,
	.tp_new = py_notify_entry_new,
};


static PyObject *py_notify_entry_array_get_num_entries(PyObject *obj, void *closure)
{
	struct notify_entry_array *object = (struct notify_entry_array *)pytalloc_get_ptr(obj);
	PyObject *py_num_entries;
	py_num_entries = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->num_entries);
	return py_num_entries;
}

static int py_notify_entry_array_set_num_entries(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_entry_array *object = (struct notify_entry_array *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->num_entries");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->num_entries));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->num_entries = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->num_entries = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_notify_entry_array_get_entries(PyObject *obj, void *closure)
{
	struct notify_entry_array *object = (struct notify_entry_array *)pytalloc_get_ptr(obj);
	PyObject *py_entries;
	py_entries = PyList_New(object->num_entries);
	if (py_entries == NULL) {
		return NULL;
	}
	{
		int entries_cntr_0;
		for (entries_cntr_0 = 0; entries_cntr_0 < (object->num_entries); entries_cntr_0++) {
			PyObject *py_entries_0;
			py_entries_0 = pytalloc_reference_ex(&notify_entry_Type, object->entries, &object->entries[entries_cntr_0]);
			PyList_SetItem(py_entries, entries_cntr_0, py_entries_0);
		}
	}
	return py_entries;
}

static int py_notify_entry_array_set_entries(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_entry_array *object = (struct notify_entry_array *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->entries");
		return -1;
	}
	PY_CHECK_TYPE(&PyList_Type, value, return -1;);
	{
		int entries_cntr_0;
		object->entries = talloc_array_ptrtype(pytalloc_get_mem_ctx(py_obj), object->entries, PyList_GET_SIZE(value));
		if (!object->entries) { return -1;; }
		talloc_set_name_const(object->entries, "ARRAY: object->entries");
		for (entries_cntr_0 = 0; entries_cntr_0 < PyList_GET_SIZE(value); entries_cntr_0++) {
			if (PyList_GET_ITEM(value, entries_cntr_0) == NULL) {
				PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->entries[entries_cntr_0]");
				return -1;
			}
			PY_CHECK_TYPE(&notify_entry_Type, PyList_GET_ITEM(value, entries_cntr_0), return -1;);
			if (talloc_reference(object->entries, pytalloc_get_mem_ctx(PyList_GET_ITEM(value, entries_cntr_0))) == NULL) {
				PyErr_NoMemory();
				return -1;
			}
			object->entries[entries_cntr_0] = *(struct notify_entry *)pytalloc_get_ptr(PyList_GET_ITEM(value, entries_cntr_0));
		}
	}
	return 0;
}

static PyGetSetDef py_notify_entry_array_getsetters[] = {
	{
		.name = discard_const_p(char, "num_entries"),
		.get = py_notify_entry_array_get_num_entries,
		.set = py_notify_entry_array_set_num_entries,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint32")
	},
	{
		.name = discard_const_p(char, "entries"),
		.get = py_notify_entry_array_get_entries,
		.set = py_notify_entry_array_set_entries,
		.doc = discard_const_p(char, "PIDL-generated element of base type notify_entry")
	},
	{ .name = NULL }
};

static PyObject *py_notify_entry_array_new(PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
	return pytalloc_new(struct notify_entry_array, type);
}

static PyObject *py_notify_entry_array_ndr_pack(PyObject *py_obj)
{
	struct notify_entry_array *object = (struct notify_entry_array *)pytalloc_get_ptr(py_obj);
	PyObject *ret = NULL;
	DATA_BLOB blob;
	enum ndr_err_code err;
	TALLOC_CTX *tmp_ctx = talloc_new(pytalloc_get_mem_ctx(py_obj));
	if (tmp_ctx == NULL) {
		PyErr_SetNdrError(NDR_ERR_ALLOC);
		return NULL;
	}
	err = ndr_push_struct_blob(&blob, tmp_ctx, object, (ndr_push_flags_fn_t)ndr_push_notify_entry_array);
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		TALLOC_FREE(tmp_ctx);
		PyErr_SetNdrError(err);
		return NULL;
	}

	ret = PyBytes_FromStringAndSize((char *)blob.data, blob.length);
	TALLOC_FREE(tmp_ctx);
	return ret;
}

static PyObject *py_notify_entry_array_ndr_unpack(PyObject *py_obj, PyObject *args, PyObject *kwargs)
{
	struct notify_entry_array *object = (struct notify_entry_array *)pytalloc_get_ptr(py_obj);
	DATA_BLOB blob;
	Py_ssize_t blob_length = 0;
	enum ndr_err_code err;
	const char * const kwnames[] = { "data_blob", "allow_remaining", NULL };
	PyObject *allow_remaining_obj = NULL;
	bool allow_remaining = false;

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, PYARG_BYTES_LEN "|O:__ndr_unpack__",
		discard_const_p(char *, kwnames),
		&blob.data, &blob_length,
		&allow_remaining_obj)) {
		return NULL;
	}
	blob.length = blob_length;

	if (allow_remaining_obj && PyObject_IsTrue(allow_remaining_obj)) {
		allow_remaining = true;
	}

	if (allow_remaining) {
		err = ndr_pull_struct_blob(&blob, pytalloc_get_mem_ctx(py_obj), object, (ndr_pull_flags_fn_t)ndr_pull_notify_entry_array);
	} else {
		err = ndr_pull_struct_blob_all(&blob, pytalloc_get_mem_ctx(py_obj), object, (ndr_pull_flags_fn_t)ndr_pull_notify_entry_array);
	}
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		PyErr_SetNdrError(err);
		return NULL;
	}

	Py_RETURN_NONE;
}

static PyObject *py_notify_entry_array_ndr_print(PyObject *py_obj)
{
	struct notify_entry_array *object = (struct notify_entry_array *)pytalloc_get_ptr(py_obj);
	PyObject *ret;
	char *retstr;

	retstr = ndr_print_struct_string(pytalloc_get_mem_ctx(py_obj), (ndr_print_fn_t)ndr_print_notify_entry_array, "notify_entry_array", object);
	ret = PyStr_FromString(retstr);
	talloc_free(retstr);

	return ret;
}

static PyMethodDef py_notify_entry_array_methods[] = {
	{ "__ndr_pack__", (PyCFunction)py_notify_entry_array_ndr_pack, METH_NOARGS, "S.ndr_pack(object) -> blob\nNDR pack" },
	{ "__ndr_unpack__", (PyCFunction)py_notify_entry_array_ndr_unpack, METH_VARARGS|METH_KEYWORDS, "S.ndr_unpack(class, blob, allow_remaining=False) -> None\nNDR unpack" },
	{ "__ndr_print__", (PyCFunction)py_notify_entry_array_ndr_print, METH_NOARGS, "S.ndr_print(object) -> None\nNDR print" },
	{ NULL, NULL, 0, NULL }
};


static PyTypeObject notify_entry_array_Type = {
	PyVarObject_HEAD_INIT(NULL, 0)
	.tp_name = "notify.entry_array",
	.tp_getset = py_notify_entry_array_getsetters,
	.tp_methods = py_notify_entry_array_methods,
	.tp_flags = Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,
	.tp_new = py_notify_entry_array_new,
};


static PyObject *py_notify_db_entry_get_server(PyObject *obj, void *closure)
{
	struct notify_db_entry *object = (struct notify_db_entry *)pytalloc_get_ptr(obj);
	PyObject *py_server;
	py_server = pytalloc_reference_ex(server_id_Type, pytalloc_get_mem_ctx(obj), &object->server);
	return py_server;
}

static int py_notify_db_entry_set_server(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_db_entry *object = (struct notify_db_entry *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->server");
		return -1;
	}
	PY_CHECK_TYPE(server_id_Type, value, return -1;);
	if (talloc_reference(pytalloc_get_mem_ctx(py_obj), pytalloc_get_mem_ctx(value)) == NULL) {
		PyErr_NoMemory();
		return -1;
	}
	object->server = *(struct server_id *)pytalloc_get_ptr(value);
	return 0;
}

static PyObject *py_notify_db_entry_get_filter(PyObject *obj, void *closure)
{
	struct notify_db_entry *object = (struct notify_db_entry *)pytalloc_get_ptr(obj);
	PyObject *py_filter;
	py_filter = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->filter);
	return py_filter;
}

static int py_notify_db_entry_set_filter(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_db_entry *object = (struct notify_db_entry *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->filter");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->filter));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->filter = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->filter = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_notify_db_entry_get_subdir_filter(PyObject *obj, void *closure)
{
	struct notify_db_entry *object = (struct notify_db_entry *)pytalloc_get_ptr(obj);
	PyObject *py_subdir_filter;
	py_subdir_filter = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->subdir_filter);
	return py_subdir_filter;
}

static int py_notify_db_entry_set_subdir_filter(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_db_entry *object = (struct notify_db_entry *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->subdir_filter");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->subdir_filter));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->subdir_filter = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->subdir_filter = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_notify_db_entry_get_private_data(PyObject *obj, void *closure)
{
	struct notify_db_entry *object = (struct notify_db_entry *)pytalloc_get_ptr(obj);
	PyObject *py_private_data;
	py_private_data = pytalloc_GenericObject_reference_ex(pytalloc_get_mem_ctx(obj), object->private_data);
	return py_private_data;
}

static int py_notify_db_entry_set_private_data(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_db_entry *object = (struct notify_db_entry *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->private_data");
		return -1;
	}
	object->private_data = pytalloc_get_ptr(value);
	return 0;
}

static PyGetSetDef py_notify_db_entry_getsetters[] = {
	{
		.name = discard_const_p(char, "server"),
		.get = py_notify_db_entry_get_server,
		.set = py_notify_db_entry_set_server,
		.doc = discard_const_p(char, "PIDL-generated element of base type server_id")
	},
	{
		.name = discard_const_p(char, "filter"),
		.get = py_notify_db_entry_get_filter,
		.set = py_notify_db_entry_set_filter,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint32")
	},
	{
		.name = discard_const_p(char, "subdir_filter"),
		.get = py_notify_db_entry_get_subdir_filter,
		.set = py_notify_db_entry_set_subdir_filter,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint32")
	},
	{
		.name = discard_const_p(char, "private_data"),
		.get = py_notify_db_entry_get_private_data,
		.set = py_notify_db_entry_set_private_data,
		.doc = discard_const_p(char, "PIDL-generated element of base type pointer")
	},
	{ .name = NULL }
};

static PyObject *py_notify_db_entry_new(PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
	return pytalloc_new(struct notify_db_entry, type);
}

static PyObject *py_notify_db_entry_ndr_pack(PyObject *py_obj)
{
	struct notify_db_entry *object = (struct notify_db_entry *)pytalloc_get_ptr(py_obj);
	PyObject *ret = NULL;
	DATA_BLOB blob;
	enum ndr_err_code err;
	TALLOC_CTX *tmp_ctx = talloc_new(pytalloc_get_mem_ctx(py_obj));
	if (tmp_ctx == NULL) {
		PyErr_SetNdrError(NDR_ERR_ALLOC);
		return NULL;
	}
	err = ndr_push_struct_blob(&blob, tmp_ctx, object, (ndr_push_flags_fn_t)ndr_push_notify_db_entry);
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		TALLOC_FREE(tmp_ctx);
		PyErr_SetNdrError(err);
		return NULL;
	}

	ret = PyBytes_FromStringAndSize((char *)blob.data, blob.length);
	TALLOC_FREE(tmp_ctx);
	return ret;
}

static PyObject *py_notify_db_entry_ndr_unpack(PyObject *py_obj, PyObject *args, PyObject *kwargs)
{
	struct notify_db_entry *object = (struct notify_db_entry *)pytalloc_get_ptr(py_obj);
	DATA_BLOB blob;
	Py_ssize_t blob_length = 0;
	enum ndr_err_code err;
	const char * const kwnames[] = { "data_blob", "allow_remaining", NULL };
	PyObject *allow_remaining_obj = NULL;
	bool allow_remaining = false;

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, PYARG_BYTES_LEN "|O:__ndr_unpack__",
		discard_const_p(char *, kwnames),
		&blob.data, &blob_length,
		&allow_remaining_obj)) {
		return NULL;
	}
	blob.length = blob_length;

	if (allow_remaining_obj && PyObject_IsTrue(allow_remaining_obj)) {
		allow_remaining = true;
	}

	if (allow_remaining) {
		err = ndr_pull_struct_blob(&blob, pytalloc_get_mem_ctx(py_obj), object, (ndr_pull_flags_fn_t)ndr_pull_notify_db_entry);
	} else {
		err = ndr_pull_struct_blob_all(&blob, pytalloc_get_mem_ctx(py_obj), object, (ndr_pull_flags_fn_t)ndr_pull_notify_db_entry);
	}
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		PyErr_SetNdrError(err);
		return NULL;
	}

	Py_RETURN_NONE;
}

static PyObject *py_notify_db_entry_ndr_print(PyObject *py_obj)
{
	struct notify_db_entry *object = (struct notify_db_entry *)pytalloc_get_ptr(py_obj);
	PyObject *ret;
	char *retstr;

	retstr = ndr_print_struct_string(pytalloc_get_mem_ctx(py_obj), (ndr_print_fn_t)ndr_print_notify_db_entry, "notify_db_entry", object);
	ret = PyStr_FromString(retstr);
	talloc_free(retstr);

	return ret;
}

static PyMethodDef py_notify_db_entry_methods[] = {
	{ "__ndr_pack__", (PyCFunction)py_notify_db_entry_ndr_pack, METH_NOARGS, "S.ndr_pack(object) -> blob\nNDR pack" },
	{ "__ndr_unpack__", (PyCFunction)py_notify_db_entry_ndr_unpack, METH_VARARGS|METH_KEYWORDS, "S.ndr_unpack(class, blob, allow_remaining=False) -> None\nNDR unpack" },
	{ "__ndr_print__", (PyCFunction)py_notify_db_entry_ndr_print, METH_NOARGS, "S.ndr_print(object) -> None\nNDR print" },
	{ NULL, NULL, 0, NULL }
};


static PyTypeObject notify_db_entry_Type = {
	PyVarObject_HEAD_INIT(NULL, 0)
	.tp_name = "notify.db_entry",
	.tp_getset = py_notify_db_entry_getsetters,
	.tp_methods = py_notify_db_entry_methods,
	.tp_flags = Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,
	.tp_new = py_notify_db_entry_new,
};


static PyObject *py_notify_depth_get_max_mask(PyObject *obj, void *closure)
{
	struct notify_depth *object = (struct notify_depth *)pytalloc_get_ptr(obj);
	PyObject *py_max_mask;
	py_max_mask = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->max_mask);
	return py_max_mask;
}

static int py_notify_depth_set_max_mask(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_depth *object = (struct notify_depth *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->max_mask");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->max_mask));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->max_mask = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->max_mask = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_notify_depth_get_max_mask_subdir(PyObject *obj, void *closure)
{
	struct notify_depth *object = (struct notify_depth *)pytalloc_get_ptr(obj);
	PyObject *py_max_mask_subdir;
	py_max_mask_subdir = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->max_mask_subdir);
	return py_max_mask_subdir;
}

static int py_notify_depth_set_max_mask_subdir(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_depth *object = (struct notify_depth *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->max_mask_subdir");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->max_mask_subdir));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->max_mask_subdir = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->max_mask_subdir = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_notify_depth_get_num_entries(PyObject *obj, void *closure)
{
	struct notify_depth *object = (struct notify_depth *)pytalloc_get_ptr(obj);
	PyObject *py_num_entries;
	py_num_entries = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->num_entries);
	return py_num_entries;
}

static int py_notify_depth_set_num_entries(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_depth *object = (struct notify_depth *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->num_entries");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->num_entries));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->num_entries = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->num_entries = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_notify_depth_get_entries(PyObject *obj, void *closure)
{
	struct notify_depth *object = (struct notify_depth *)pytalloc_get_ptr(obj);
	PyObject *py_entries;
	py_entries = PyList_New(object->num_entries);
	if (py_entries == NULL) {
		return NULL;
	}
	{
		int entries_cntr_0;
		for (entries_cntr_0 = 0; entries_cntr_0 < (object->num_entries); entries_cntr_0++) {
			PyObject *py_entries_0;
			py_entries_0 = pytalloc_reference_ex(&notify_entry_Type, object->entries, &object->entries[entries_cntr_0]);
			PyList_SetItem(py_entries, entries_cntr_0, py_entries_0);
		}
	}
	return py_entries;
}

static int py_notify_depth_set_entries(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_depth *object = (struct notify_depth *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->entries");
		return -1;
	}
	PY_CHECK_TYPE(&PyList_Type, value, return -1;);
	{
		int entries_cntr_0;
		object->entries = talloc_array_ptrtype(pytalloc_get_mem_ctx(py_obj), object->entries, PyList_GET_SIZE(value));
		if (!object->entries) { return -1;; }
		talloc_set_name_const(object->entries, "ARRAY: object->entries");
		for (entries_cntr_0 = 0; entries_cntr_0 < PyList_GET_SIZE(value); entries_cntr_0++) {
			if (PyList_GET_ITEM(value, entries_cntr_0) == NULL) {
				PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->entries[entries_cntr_0]");
				return -1;
			}
			PY_CHECK_TYPE(&notify_entry_Type, PyList_GET_ITEM(value, entries_cntr_0), return -1;);
			if (talloc_reference(object->entries, pytalloc_get_mem_ctx(PyList_GET_ITEM(value, entries_cntr_0))) == NULL) {
				PyErr_NoMemory();
				return -1;
			}
			object->entries[entries_cntr_0] = *(struct notify_entry *)pytalloc_get_ptr(PyList_GET_ITEM(value, entries_cntr_0));
		}
	}
	return 0;
}

static PyGetSetDef py_notify_depth_getsetters[] = {
	{
		.name = discard_const_p(char, "max_mask"),
		.get = py_notify_depth_get_max_mask,
		.set = py_notify_depth_set_max_mask,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint32")
	},
	{
		.name = discard_const_p(char, "max_mask_subdir"),
		.get = py_notify_depth_get_max_mask_subdir,
		.set = py_notify_depth_set_max_mask_subdir,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint32")
	},
	{
		.name = discard_const_p(char, "num_entries"),
		.get = py_notify_depth_get_num_entries,
		.set = py_notify_depth_set_num_entries,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint32")
	},
	{
		.name = discard_const_p(char, "entries"),
		.get = py_notify_depth_get_entries,
		.set = py_notify_depth_set_entries,
		.doc = discard_const_p(char, "PIDL-generated element of base type notify_entry")
	},
	{ .name = NULL }
};

static PyObject *py_notify_depth_new(PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
	return pytalloc_new(struct notify_depth, type);
}


static PyTypeObject notify_depth_Type = {
	PyVarObject_HEAD_INIT(NULL, 0)
	.tp_name = "notify.depth",
	.tp_getset = py_notify_depth_getsetters,
	.tp_methods = NULL,
	.tp_flags = Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,
	.tp_new = py_notify_depth_new,
};


static PyObject *py_notify_array_get_num_depths(PyObject *obj, void *closure)
{
	struct notify_array *object = (struct notify_array *)pytalloc_get_ptr(obj);
	PyObject *py_num_depths;
	py_num_depths = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->num_depths);
	return py_num_depths;
}

static int py_notify_array_set_num_depths(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_array *object = (struct notify_array *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->num_depths");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->num_depths));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->num_depths = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->num_depths = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_notify_array_get_depth(PyObject *obj, void *closure)
{
	struct notify_array *object = (struct notify_array *)pytalloc_get_ptr(obj);
	PyObject *py_depth;
	py_depth = PyList_New(object->num_depths);
	if (py_depth == NULL) {
		return NULL;
	}
	{
		int depth_cntr_0;
		for (depth_cntr_0 = 0; depth_cntr_0 < (object->num_depths); depth_cntr_0++) {
			PyObject *py_depth_0;
			py_depth_0 = pytalloc_reference_ex(&notify_depth_Type, object->depth, &object->depth[depth_cntr_0]);
			PyList_SetItem(py_depth, depth_cntr_0, py_depth_0);
		}
	}
	return py_depth;
}

static int py_notify_array_set_depth(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_array *object = (struct notify_array *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->depth");
		return -1;
	}
	PY_CHECK_TYPE(&PyList_Type, value, return -1;);
	{
		int depth_cntr_0;
		object->depth = talloc_array_ptrtype(pytalloc_get_mem_ctx(py_obj), object->depth, PyList_GET_SIZE(value));
		if (!object->depth) { return -1;; }
		talloc_set_name_const(object->depth, "ARRAY: object->depth");
		for (depth_cntr_0 = 0; depth_cntr_0 < PyList_GET_SIZE(value); depth_cntr_0++) {
			if (PyList_GET_ITEM(value, depth_cntr_0) == NULL) {
				PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->depth[depth_cntr_0]");
				return -1;
			}
			PY_CHECK_TYPE(&notify_depth_Type, PyList_GET_ITEM(value, depth_cntr_0), return -1;);
			if (talloc_reference(object->depth, pytalloc_get_mem_ctx(PyList_GET_ITEM(value, depth_cntr_0))) == NULL) {
				PyErr_NoMemory();
				return -1;
			}
			object->depth[depth_cntr_0] = *(struct notify_depth *)pytalloc_get_ptr(PyList_GET_ITEM(value, depth_cntr_0));
		}
	}
	return 0;
}

static PyGetSetDef py_notify_array_getsetters[] = {
	{
		.name = discard_const_p(char, "num_depths"),
		.get = py_notify_array_get_num_depths,
		.set = py_notify_array_set_num_depths,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint32")
	},
	{
		.name = discard_const_p(char, "depth"),
		.get = py_notify_array_get_depth,
		.set = py_notify_array_set_depth,
		.doc = discard_const_p(char, "PIDL-generated element of base type notify_depth")
	},
	{ .name = NULL }
};

static PyObject *py_notify_array_new(PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
	return pytalloc_new(struct notify_array, type);
}

static PyObject *py_notify_array_ndr_pack(PyObject *py_obj)
{
	struct notify_array *object = (struct notify_array *)pytalloc_get_ptr(py_obj);
	PyObject *ret = NULL;
	DATA_BLOB blob;
	enum ndr_err_code err;
	TALLOC_CTX *tmp_ctx = talloc_new(pytalloc_get_mem_ctx(py_obj));
	if (tmp_ctx == NULL) {
		PyErr_SetNdrError(NDR_ERR_ALLOC);
		return NULL;
	}
	err = ndr_push_struct_blob(&blob, tmp_ctx, object, (ndr_push_flags_fn_t)ndr_push_notify_array);
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		TALLOC_FREE(tmp_ctx);
		PyErr_SetNdrError(err);
		return NULL;
	}

	ret = PyBytes_FromStringAndSize((char *)blob.data, blob.length);
	TALLOC_FREE(tmp_ctx);
	return ret;
}

static PyObject *py_notify_array_ndr_unpack(PyObject *py_obj, PyObject *args, PyObject *kwargs)
{
	struct notify_array *object = (struct notify_array *)pytalloc_get_ptr(py_obj);
	DATA_BLOB blob;
	Py_ssize_t blob_length = 0;
	enum ndr_err_code err;
	const char * const kwnames[] = { "data_blob", "allow_remaining", NULL };
	PyObject *allow_remaining_obj = NULL;
	bool allow_remaining = false;

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, PYARG_BYTES_LEN "|O:__ndr_unpack__",
		discard_const_p(char *, kwnames),
		&blob.data, &blob_length,
		&allow_remaining_obj)) {
		return NULL;
	}
	blob.length = blob_length;

	if (allow_remaining_obj && PyObject_IsTrue(allow_remaining_obj)) {
		allow_remaining = true;
	}

	if (allow_remaining) {
		err = ndr_pull_struct_blob(&blob, pytalloc_get_mem_ctx(py_obj), object, (ndr_pull_flags_fn_t)ndr_pull_notify_array);
	} else {
		err = ndr_pull_struct_blob_all(&blob, pytalloc_get_mem_ctx(py_obj), object, (ndr_pull_flags_fn_t)ndr_pull_notify_array);
	}
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		PyErr_SetNdrError(err);
		return NULL;
	}

	Py_RETURN_NONE;
}

static PyObject *py_notify_array_ndr_print(PyObject *py_obj)
{
	struct notify_array *object = (struct notify_array *)pytalloc_get_ptr(py_obj);
	PyObject *ret;
	char *retstr;

	retstr = ndr_print_struct_string(pytalloc_get_mem_ctx(py_obj), (ndr_print_fn_t)ndr_print_notify_array, "notify_array", object);
	ret = PyStr_FromString(retstr);
	talloc_free(retstr);

	return ret;
}

static PyMethodDef py_notify_array_methods[] = {
	{ "__ndr_pack__", (PyCFunction)py_notify_array_ndr_pack, METH_NOARGS, "S.ndr_pack(object) -> blob\nNDR pack" },
	{ "__ndr_unpack__", (PyCFunction)py_notify_array_ndr_unpack, METH_VARARGS|METH_KEYWORDS, "S.ndr_unpack(class, blob, allow_remaining=False) -> None\nNDR unpack" },
	{ "__ndr_print__", (PyCFunction)py_notify_array_ndr_print, METH_NOARGS, "S.ndr_print(object) -> None\nNDR print" },
	{ NULL, NULL, 0, NULL }
};


static PyTypeObject notify_array_Type = {
	PyVarObject_HEAD_INIT(NULL, 0)
	.tp_name = "notify.array",
	.tp_getset = py_notify_array_getsetters,
	.tp_methods = py_notify_array_methods,
	.tp_flags = Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,
	.tp_new = py_notify_array_new,
};


static PyObject *py_notify_event_get_action(PyObject *obj, void *closure)
{
	struct notify_event *object = (struct notify_event *)pytalloc_get_ptr(obj);
	PyObject *py_action;
	py_action = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->action);
	return py_action;
}

static int py_notify_event_set_action(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_event *object = (struct notify_event *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->action");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->action));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->action = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->action = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_notify_event_get_dir(PyObject *obj, void *closure)
{
	struct notify_event *object = (struct notify_event *)pytalloc_get_ptr(obj);
	PyObject *py_dir;
	py_dir = PyString_FromStringOrNULL(object->dir);
	return py_dir;
}

static int py_notify_event_set_dir(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_event *object = (struct notify_event *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->dir");
		return -1;
	}
	{
		const char *test_str;
		const char *talloc_str;
		PyObject *unicode = NULL;
		if (PyUnicode_Check(value)) {
			unicode = PyUnicode_AsEncodedString(value, "utf-8", "ignore");
			if (unicode == NULL) {
				PyErr_NoMemory();
				return -1;
			}
			test_str = PyBytes_AS_STRING(unicode);
		} else if (PyBytes_Check(value)) {
			test_str = PyBytes_AS_STRING(value);
		} else {
			PyErr_Format(PyExc_TypeError, "Expected string or unicode object, got %s", Py_TYPE(value)->tp_name);
			return -1;
		}
		talloc_str = talloc_strdup(pytalloc_get_mem_ctx(py_obj), test_str);
		if (unicode != NULL) {
			Py_DECREF(unicode);
		}
		if (talloc_str == NULL) {
			PyErr_NoMemory();
			return -1;
		}
		object->dir = talloc_str;
	}
	return 0;
}

static PyObject *py_notify_event_get_path(PyObject *obj, void *closure)
{
	struct notify_event *object = (struct notify_event *)pytalloc_get_ptr(obj);
	PyObject *py_path;
	py_path = PyString_FromStringOrNULL(object->path);
	return py_path;
}

static int py_notify_event_set_path(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_event *object = (struct notify_event *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->path");
		return -1;
	}
	{
		const char *test_str;
		const char *talloc_str;
		PyObject *unicode = NULL;
		if (PyUnicode_Check(value)) {
			unicode = PyUnicode_AsEncodedString(value, "utf-8", "ignore");
			if (unicode == NULL) {
				PyErr_NoMemory();
				return -1;
			}
			test_str = PyBytes_AS_STRING(unicode);
		} else if (PyBytes_Check(value)) {
			test_str = PyBytes_AS_STRING(value);
		} else {
			PyErr_Format(PyExc_TypeError, "Expected string or unicode object, got %s", Py_TYPE(value)->tp_name);
			return -1;
		}
		talloc_str = talloc_strdup(pytalloc_get_mem_ctx(py_obj), test_str);
		if (unicode != NULL) {
			Py_DECREF(unicode);
		}
		if (talloc_str == NULL) {
			PyErr_NoMemory();
			return -1;
		}
		object->path = talloc_str;
	}
	return 0;
}

static PyObject *py_notify_event_get_private_data(PyObject *obj, void *closure)
{
	struct notify_event *object = (struct notify_event *)pytalloc_get_ptr(obj);
	PyObject *py_private_data;
	py_private_data = pytalloc_GenericObject_reference_ex(pytalloc_get_mem_ctx(obj), object->private_data);
	return py_private_data;
}

static int py_notify_event_set_private_data(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_event *object = (struct notify_event *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->private_data");
		return -1;
	}
	object->private_data = pytalloc_get_ptr(value);
	return 0;
}

static PyGetSetDef py_notify_event_getsetters[] = {
	{
		.name = discard_const_p(char, "action"),
		.get = py_notify_event_get_action,
		.set = py_notify_event_set_action,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint32")
	},
	{
		.name = discard_const_p(char, "dir"),
		.get = py_notify_event_get_dir,
		.set = py_notify_event_set_dir,
		.doc = discard_const_p(char, "PIDL-generated element of base type string")
	},
	{
		.name = discard_const_p(char, "path"),
		.get = py_notify_event_get_path,
		.set = py_notify_event_set_path,
		.doc = discard_const_p(char, "PIDL-generated element of base type string")
	},
	{
		.name = discard_const_p(char, "private_data"),
		.get = py_notify_event_get_private_data,
		.set = py_notify_event_set_private_data,
		.doc = discard_const_p(char, "PIDL-generated element of base type pointer")
	},
	{ .name = NULL }
};

static PyObject *py_notify_event_new(PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
	return pytalloc_new(struct notify_event, type);
}

static PyObject *py_notify_event_ndr_pack(PyObject *py_obj)
{
	struct notify_event *object = (struct notify_event *)pytalloc_get_ptr(py_obj);
	PyObject *ret = NULL;
	DATA_BLOB blob;
	enum ndr_err_code err;
	TALLOC_CTX *tmp_ctx = talloc_new(pytalloc_get_mem_ctx(py_obj));
	if (tmp_ctx == NULL) {
		PyErr_SetNdrError(NDR_ERR_ALLOC);
		return NULL;
	}
	err = ndr_push_struct_blob(&blob, tmp_ctx, object, (ndr_push_flags_fn_t)ndr_push_notify_event);
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		TALLOC_FREE(tmp_ctx);
		PyErr_SetNdrError(err);
		return NULL;
	}

	ret = PyBytes_FromStringAndSize((char *)blob.data, blob.length);
	TALLOC_FREE(tmp_ctx);
	return ret;
}

static PyObject *py_notify_event_ndr_unpack(PyObject *py_obj, PyObject *args, PyObject *kwargs)
{
	struct notify_event *object = (struct notify_event *)pytalloc_get_ptr(py_obj);
	DATA_BLOB blob;
	Py_ssize_t blob_length = 0;
	enum ndr_err_code err;
	const char * const kwnames[] = { "data_blob", "allow_remaining", NULL };
	PyObject *allow_remaining_obj = NULL;
	bool allow_remaining = false;

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, PYARG_BYTES_LEN "|O:__ndr_unpack__",
		discard_const_p(char *, kwnames),
		&blob.data, &blob_length,
		&allow_remaining_obj)) {
		return NULL;
	}
	blob.length = blob_length;

	if (allow_remaining_obj && PyObject_IsTrue(allow_remaining_obj)) {
		allow_remaining = true;
	}

	if (allow_remaining) {
		err = ndr_pull_struct_blob(&blob, pytalloc_get_mem_ctx(py_obj), object, (ndr_pull_flags_fn_t)ndr_pull_notify_event);
	} else {
		err = ndr_pull_struct_blob_all(&blob, pytalloc_get_mem_ctx(py_obj), object, (ndr_pull_flags_fn_t)ndr_pull_notify_event);
	}
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		PyErr_SetNdrError(err);
		return NULL;
	}

	Py_RETURN_NONE;
}

static PyObject *py_notify_event_ndr_print(PyObject *py_obj)
{
	struct notify_event *object = (struct notify_event *)pytalloc_get_ptr(py_obj);
	PyObject *ret;
	char *retstr;

	retstr = ndr_print_struct_string(pytalloc_get_mem_ctx(py_obj), (ndr_print_fn_t)ndr_print_notify_event, "notify_event", object);
	ret = PyStr_FromString(retstr);
	talloc_free(retstr);

	return ret;
}

static PyMethodDef py_notify_event_methods[] = {
	{ "__ndr_pack__", (PyCFunction)py_notify_event_ndr_pack, METH_NOARGS, "S.ndr_pack(object) -> blob\nNDR pack" },
	{ "__ndr_unpack__", (PyCFunction)py_notify_event_ndr_unpack, METH_VARARGS|METH_KEYWORDS, "S.ndr_unpack(class, blob, allow_remaining=False) -> None\nNDR unpack" },
	{ "__ndr_print__", (PyCFunction)py_notify_event_ndr_print, METH_NOARGS, "S.ndr_print(object) -> None\nNDR print" },
	{ NULL, NULL, 0, NULL }
};


static PyTypeObject notify_event_Type = {
	PyVarObject_HEAD_INIT(NULL, 0)
	.tp_name = "notify.event",
	.tp_getset = py_notify_event_getsetters,
	.tp_methods = py_notify_event_methods,
	.tp_flags = Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,
	.tp_new = py_notify_event_new,
};


static PyObject *py_notify_remote_event_get_action(PyObject *obj, void *closure)
{
	struct notify_remote_event *object = (struct notify_remote_event *)pytalloc_get_ptr(obj);
	PyObject *py_action;
	py_action = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->action);
	return py_action;
}

static int py_notify_remote_event_set_action(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_remote_event *object = (struct notify_remote_event *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->action");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->action));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->action = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->action = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_notify_remote_event_get_filter(PyObject *obj, void *closure)
{
	struct notify_remote_event *object = (struct notify_remote_event *)pytalloc_get_ptr(obj);
	PyObject *py_filter;
	py_filter = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->filter);
	return py_filter;
}

static int py_notify_remote_event_set_filter(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_remote_event *object = (struct notify_remote_event *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->filter");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->filter));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->filter = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->filter = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_notify_remote_event_get_path(PyObject *obj, void *closure)
{
	struct notify_remote_event *object = (struct notify_remote_event *)pytalloc_get_ptr(obj);
	PyObject *py_path;
	py_path = PyString_FromStringOrNULL(object->path);
	return py_path;
}

static int py_notify_remote_event_set_path(PyObject *py_obj, PyObject *value, void *closure)
{
	struct notify_remote_event *object = (struct notify_remote_event *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->path");
		return -1;
	}
	{
		const char *test_str;
		const char *talloc_str;
		PyObject *unicode = NULL;
		if (PyUnicode_Check(value)) {
			unicode = PyUnicode_AsEncodedString(value, "utf-8", "ignore");
			if (unicode == NULL) {
				PyErr_NoMemory();
				return -1;
			}
			test_str = PyBytes_AS_STRING(unicode);
		} else if (PyBytes_Check(value)) {
			test_str = PyBytes_AS_STRING(value);
		} else {
			PyErr_Format(PyExc_TypeError, "Expected string or unicode object, got %s", Py_TYPE(value)->tp_name);
			return -1;
		}
		talloc_str = talloc_strdup(pytalloc_get_mem_ctx(py_obj), test_str);
		if (unicode != NULL) {
			Py_DECREF(unicode);
		}
		if (talloc_str == NULL) {
			PyErr_NoMemory();
			return -1;
		}
		object->path = talloc_str;
	}
	return 0;
}

static PyGetSetDef py_notify_remote_event_getsetters[] = {
	{
		.name = discard_const_p(char, "action"),
		.get = py_notify_remote_event_get_action,
		.set = py_notify_remote_event_set_action,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint32")
	},
	{
		.name = discard_const_p(char, "filter"),
		.get = py_notify_remote_event_get_filter,
		.set = py_notify_remote_event_set_filter,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint32")
	},
	{
		.name = discard_const_p(char, "path"),
		.get = py_notify_remote_event_get_path,
		.set = py_notify_remote_event_set_path,
		.doc = discard_const_p(char, "PIDL-generated element of base type string")
	},
	{ .name = NULL }
};

static PyObject *py_notify_remote_event_new(PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
	return pytalloc_new(struct notify_remote_event, type);
}

static PyObject *py_notify_remote_event_ndr_pack(PyObject *py_obj)
{
	struct notify_remote_event *object = (struct notify_remote_event *)pytalloc_get_ptr(py_obj);
	PyObject *ret = NULL;
	DATA_BLOB blob;
	enum ndr_err_code err;
	TALLOC_CTX *tmp_ctx = talloc_new(pytalloc_get_mem_ctx(py_obj));
	if (tmp_ctx == NULL) {
		PyErr_SetNdrError(NDR_ERR_ALLOC);
		return NULL;
	}
	err = ndr_push_struct_blob(&blob, tmp_ctx, object, (ndr_push_flags_fn_t)ndr_push_notify_remote_event);
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		TALLOC_FREE(tmp_ctx);
		PyErr_SetNdrError(err);
		return NULL;
	}

	ret = PyBytes_FromStringAndSize((char *)blob.data, blob.length);
	TALLOC_FREE(tmp_ctx);
	return ret;
}

static PyObject *py_notify_remote_event_ndr_unpack(PyObject *py_obj, PyObject *args, PyObject *kwargs)
{
	struct notify_remote_event *object = (struct notify_remote_event *)pytalloc_get_ptr(py_obj);
	DATA_BLOB blob;
	Py_ssize_t blob_length = 0;
	enum ndr_err_code err;
	const char * const kwnames[] = { "data_blob", "allow_remaining", NULL };
	PyObject *allow_remaining_obj = NULL;
	bool allow_remaining = false;

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, PYARG_BYTES_LEN "|O:__ndr_unpack__",
		discard_const_p(char *, kwnames),
		&blob.data, &blob_length,
		&allow_remaining_obj)) {
		return NULL;
	}
	blob.length = blob_length;

	if (allow_remaining_obj && PyObject_IsTrue(allow_remaining_obj)) {
		allow_remaining = true;
	}

	if (allow_remaining) {
		err = ndr_pull_struct_blob(&blob, pytalloc_get_mem_ctx(py_obj), object, (ndr_pull_flags_fn_t)ndr_pull_notify_remote_event);
	} else {
		err = ndr_pull_struct_blob_all(&blob, pytalloc_get_mem_ctx(py_obj), object, (ndr_pull_flags_fn_t)ndr_pull_notify_remote_event);
	}
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		PyErr_SetNdrError(err);
		return NULL;
	}

	Py_RETURN_NONE;
}

static PyObject *py_notify_remote_event_ndr_print(PyObject *py_obj)
{
	struct notify_remote_event *object = (struct notify_remote_event *)pytalloc_get_ptr(py_obj);
	PyObject *ret;
	char *retstr;

	retstr = ndr_print_struct_string(pytalloc_get_mem_ctx(py_obj), (ndr_print_fn_t)ndr_print_notify_remote_event, "notify_remote_event", object);
	ret = PyStr_FromString(retstr);
	talloc_free(retstr);

	return ret;
}

static PyMethodDef py_notify_remote_event_methods[] = {
	{ "__ndr_pack__", (PyCFunction)py_notify_remote_event_ndr_pack, METH_NOARGS, "S.ndr_pack(object) -> blob\nNDR pack" },
	{ "__ndr_unpack__", (PyCFunction)py_notify_remote_event_ndr_unpack, METH_VARARGS|METH_KEYWORDS, "S.ndr_unpack(class, blob, allow_remaining=False) -> None\nNDR unpack" },
	{ "__ndr_print__", (PyCFunction)py_notify_remote_event_ndr_print, METH_NOARGS, "S.ndr_print(object) -> None\nNDR print" },
	{ NULL, NULL, 0, NULL }
};


static PyTypeObject notify_remote_event_Type = {
	PyVarObject_HEAD_INIT(NULL, 0)
	.tp_name = "notify.remote_event",
	.tp_getset = py_notify_remote_event_getsetters,
	.tp_methods = py_notify_remote_event_methods,
	.tp_flags = Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,
	.tp_new = py_notify_remote_event_new,
};


static PyObject *py_FILE_NOTIFY_INFORMATION_get_NextEntryOffset(PyObject *obj, void *closure)
{
	struct FILE_NOTIFY_INFORMATION *object = (struct FILE_NOTIFY_INFORMATION *)pytalloc_get_ptr(obj);
	PyObject *py_NextEntryOffset;
	py_NextEntryOffset = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->NextEntryOffset);
	return py_NextEntryOffset;
}

static int py_FILE_NOTIFY_INFORMATION_set_NextEntryOffset(PyObject *py_obj, PyObject *value, void *closure)
{
	struct FILE_NOTIFY_INFORMATION *object = (struct FILE_NOTIFY_INFORMATION *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->NextEntryOffset");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->NextEntryOffset));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->NextEntryOffset = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->NextEntryOffset = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_FILE_NOTIFY_INFORMATION_get_Action(PyObject *obj, void *closure)
{
	struct FILE_NOTIFY_INFORMATION *object = (struct FILE_NOTIFY_INFORMATION *)pytalloc_get_ptr(obj);
	PyObject *py_Action;
	py_Action = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->Action);
	return py_Action;
}

static int py_FILE_NOTIFY_INFORMATION_set_Action(PyObject *py_obj, PyObject *value, void *closure)
{
	struct FILE_NOTIFY_INFORMATION *object = (struct FILE_NOTIFY_INFORMATION *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->Action");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->Action));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->Action = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->Action = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_FILE_NOTIFY_INFORMATION_get_FileNameLength(PyObject *obj, void *closure)
{
	struct FILE_NOTIFY_INFORMATION *object = (struct FILE_NOTIFY_INFORMATION *)pytalloc_get_ptr(obj);
	PyObject *py_FileNameLength;
	py_FileNameLength = ndr_PyLong_FromUnsignedLongLong((uint32_t)object->FileNameLength);
	return py_FileNameLength;
}

static int py_FILE_NOTIFY_INFORMATION_set_FileNameLength(PyObject *py_obj, PyObject *value, void *closure)
{
	struct FILE_NOTIFY_INFORMATION *object = (struct FILE_NOTIFY_INFORMATION *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->FileNameLength");
		return -1;
	}
	{
		const unsigned long long uint_max = ndr_sizeof2uintmax(sizeof(object->FileNameLength));
		if (PyLong_Check(value)) {
			unsigned long long test_var;
			test_var = PyLong_AsUnsignedLongLong(value);
			if (PyErr_Occurred() != NULL) {
				return -1;
			}
			if (test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %llu",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->FileNameLength = test_var;
		} else if (PyInt_Check(value)) {
			long test_var;
			test_var = PyInt_AsLong(value);
			if (test_var < 0 || (unsigned long long)test_var > uint_max) {
				PyErr_Format(PyExc_OverflowError, "Expected type %s or %s within range 0 - %llu, got %ld",\
				  PyInt_Type.tp_name, PyLong_Type.tp_name, uint_max, test_var);
				return -1;
			}
			object->FileNameLength = test_var;
		} else {
			PyErr_Format(PyExc_TypeError, "Expected type %s or %s",\
			  PyInt_Type.tp_name, PyLong_Type.tp_name);
			return -1;
		}
	}
	return 0;
}

static PyObject *py_FILE_NOTIFY_INFORMATION_get_FileName1(PyObject *obj, void *closure)
{
	struct FILE_NOTIFY_INFORMATION *object = (struct FILE_NOTIFY_INFORMATION *)pytalloc_get_ptr(obj);
	PyObject *py_FileName1;
	if (object->FileName1 == NULL) {
		py_FileName1 = Py_None;
		Py_INCREF(py_FileName1);
	} else {
		py_FileName1 = PyUnicode_Decode(object->FileName1, strlen(object->FileName1), "utf-8", "ignore");
	}
	return py_FileName1;
}

static int py_FILE_NOTIFY_INFORMATION_set_FileName1(PyObject *py_obj, PyObject *value, void *closure)
{
	struct FILE_NOTIFY_INFORMATION *object = (struct FILE_NOTIFY_INFORMATION *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->FileName1");
		return -1;
	}
	{
		const char *test_str;
		const char *talloc_str;
		PyObject *unicode = NULL;
		if (PyUnicode_Check(value)) {
			unicode = PyUnicode_AsEncodedString(value, "utf-8", "ignore");
			if (unicode == NULL) {
				PyErr_NoMemory();
				return -1;
			}
			test_str = PyBytes_AS_STRING(unicode);
		} else if (PyBytes_Check(value)) {
			test_str = PyBytes_AS_STRING(value);
		} else {
			PyErr_Format(PyExc_TypeError, "Expected string or unicode object, got %s", Py_TYPE(value)->tp_name);
			return -1;
		}
		talloc_str = talloc_strdup(pytalloc_get_mem_ctx(py_obj), test_str);
		if (unicode != NULL) {
			Py_DECREF(unicode);
		}
		if (talloc_str == NULL) {
			PyErr_NoMemory();
			return -1;
		}
		object->FileName1 = talloc_str;
	}
	return 0;
}

static PyObject *py_FILE_NOTIFY_INFORMATION_get__pad(PyObject *obj, void *closure)
{
	struct FILE_NOTIFY_INFORMATION *object = (struct FILE_NOTIFY_INFORMATION *)pytalloc_get_ptr(obj);
	PyObject *py__pad;
	py__pad = PyBytes_FromStringAndSize((char *)(object->_pad).data, (object->_pad).length);
	return py__pad;
}

static int py_FILE_NOTIFY_INFORMATION_set__pad(PyObject *py_obj, PyObject *value, void *closure)
{
	struct FILE_NOTIFY_INFORMATION *object = (struct FILE_NOTIFY_INFORMATION *)pytalloc_get_ptr(py_obj);
	if (value == NULL) {
		PyErr_Format(PyExc_AttributeError, "Cannot delete NDR object: struct object->_pad");
		return -1;
	}
	object->_pad = data_blob_talloc(pytalloc_get_mem_ctx(py_obj), PyBytes_AS_STRING(value), PyBytes_GET_SIZE(value));
	return 0;
}

static PyGetSetDef py_FILE_NOTIFY_INFORMATION_getsetters[] = {
	{
		.name = discard_const_p(char, "NextEntryOffset"),
		.get = py_FILE_NOTIFY_INFORMATION_get_NextEntryOffset,
		.set = py_FILE_NOTIFY_INFORMATION_set_NextEntryOffset,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint32")
	},
	{
		.name = discard_const_p(char, "Action"),
		.get = py_FILE_NOTIFY_INFORMATION_get_Action,
		.set = py_FILE_NOTIFY_INFORMATION_set_Action,
		.doc = discard_const_p(char, "PIDL-generated element of base type FILE_NOTIFY_ACTION")
	},
	{
		.name = discard_const_p(char, "FileNameLength"),
		.get = py_FILE_NOTIFY_INFORMATION_get_FileNameLength,
		.set = py_FILE_NOTIFY_INFORMATION_set_FileNameLength,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint32")
	},
	{
		.name = discard_const_p(char, "FileName1"),
		.get = py_FILE_NOTIFY_INFORMATION_get_FileName1,
		.set = py_FILE_NOTIFY_INFORMATION_set_FileName1,
		.doc = discard_const_p(char, "PIDL-generated element of base type uint16")
	},
	{
		.name = discard_const_p(char, "_pad"),
		.get = py_FILE_NOTIFY_INFORMATION_get__pad,
		.set = py_FILE_NOTIFY_INFORMATION_set__pad,
		.doc = discard_const_p(char, "PIDL-generated element of base type DATA_BLOB")
	},
	{ .name = NULL }
};

static PyObject *py_FILE_NOTIFY_INFORMATION_new(PyTypeObject *type, PyObject *args, PyObject *kwargs)
{
	return pytalloc_new(struct FILE_NOTIFY_INFORMATION, type);
}

static PyObject *py_FILE_NOTIFY_INFORMATION_ndr_pack(PyObject *py_obj)
{
	struct FILE_NOTIFY_INFORMATION *object = (struct FILE_NOTIFY_INFORMATION *)pytalloc_get_ptr(py_obj);
	PyObject *ret = NULL;
	DATA_BLOB blob;
	enum ndr_err_code err;
	TALLOC_CTX *tmp_ctx = talloc_new(pytalloc_get_mem_ctx(py_obj));
	if (tmp_ctx == NULL) {
		PyErr_SetNdrError(NDR_ERR_ALLOC);
		return NULL;
	}
	err = ndr_push_struct_blob(&blob, tmp_ctx, object, (ndr_push_flags_fn_t)ndr_push_FILE_NOTIFY_INFORMATION);
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		TALLOC_FREE(tmp_ctx);
		PyErr_SetNdrError(err);
		return NULL;
	}

	ret = PyBytes_FromStringAndSize((char *)blob.data, blob.length);
	TALLOC_FREE(tmp_ctx);
	return ret;
}

static PyObject *py_FILE_NOTIFY_INFORMATION_ndr_unpack(PyObject *py_obj, PyObject *args, PyObject *kwargs)
{
	struct FILE_NOTIFY_INFORMATION *object = (struct FILE_NOTIFY_INFORMATION *)pytalloc_get_ptr(py_obj);
	DATA_BLOB blob;
	Py_ssize_t blob_length = 0;
	enum ndr_err_code err;
	const char * const kwnames[] = { "data_blob", "allow_remaining", NULL };
	PyObject *allow_remaining_obj = NULL;
	bool allow_remaining = false;

	if (!PyArg_ParseTupleAndKeywords(args, kwargs, PYARG_BYTES_LEN "|O:__ndr_unpack__",
		discard_const_p(char *, kwnames),
		&blob.data, &blob_length,
		&allow_remaining_obj)) {
		return NULL;
	}
	blob.length = blob_length;

	if (allow_remaining_obj && PyObject_IsTrue(allow_remaining_obj)) {
		allow_remaining = true;
	}

	if (allow_remaining) {
		err = ndr_pull_struct_blob(&blob, pytalloc_get_mem_ctx(py_obj), object, (ndr_pull_flags_fn_t)ndr_pull_FILE_NOTIFY_INFORMATION);
	} else {
		err = ndr_pull_struct_blob_all(&blob, pytalloc_get_mem_ctx(py_obj), object, (ndr_pull_flags_fn_t)ndr_pull_FILE_NOTIFY_INFORMATION);
	}
	if (!NDR_ERR_CODE_IS_SUCCESS(err)) {
		PyErr_SetNdrError(err);
		return NULL;
	}

	Py_RETURN_NONE;
}

static PyObject *py_FILE_NOTIFY_INFORMATION_ndr_print(PyObject *py_obj)
{
	struct FILE_NOTIFY_INFORMATION *object = (struct FILE_NOTIFY_INFORMATION *)pytalloc_get_ptr(py_obj);
	PyObject *ret;
	char *retstr;

	retstr = ndr_print_struct_string(pytalloc_get_mem_ctx(py_obj), (ndr_print_fn_t)ndr_print_FILE_NOTIFY_INFORMATION, "FILE_NOTIFY_INFORMATION", object);
	ret = PyStr_FromString(retstr);
	talloc_free(retstr);

	return ret;
}

static PyMethodDef py_FILE_NOTIFY_INFORMATION_methods[] = {
	{ "__ndr_pack__", (PyCFunction)py_FILE_NOTIFY_INFORMATION_ndr_pack, METH_NOARGS, "S.ndr_pack(object) -> blob\nNDR pack" },
	{ "__ndr_unpack__", (PyCFunction)py_FILE_NOTIFY_INFORMATION_ndr_unpack, METH_VARARGS|METH_KEYWORDS, "S.ndr_unpack(class, blob, allow_remaining=False) -> None\nNDR unpack" },
	{ "__ndr_print__", (PyCFunction)py_FILE_NOTIFY_INFORMATION_ndr_print, METH_NOARGS, "S.ndr_print(object) -> None\nNDR print" },
	{ NULL, NULL, 0, NULL }
};


static PyTypeObject FILE_NOTIFY_INFORMATION_Type = {
	PyVarObject_HEAD_INIT(NULL, 0)
	.tp_name = "notify.FILE_NOTIFY_INFORMATION",
	.tp_getset = py_FILE_NOTIFY_INFORMATION_getsetters,
	.tp_methods = py_FILE_NOTIFY_INFORMATION_methods,
	.tp_flags = Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,
	.tp_new = py_FILE_NOTIFY_INFORMATION_new,
};

static PyMethodDef notify_methods[] = {
	{ NULL, NULL, 0, NULL }
};

static struct PyModuleDef moduledef = {
	PyModuleDef_HEAD_INIT,
	.m_name = "notify",
	.m_doc = "notify DCE/RPC",
	.m_size = -1,
	.m_methods = notify_methods,
};
MODULE_INIT_FUNC(notify)
{
	PyObject *m;
	PyObject *dep_samba_dcerpc_file_id;
	PyObject *dep_samba_dcerpc_server_id;
	PyObject *dep_talloc;

	dep_samba_dcerpc_file_id = PyImport_ImportModule("samba.dcerpc.file_id");
	if (dep_samba_dcerpc_file_id == NULL)
		return NULL;

	dep_samba_dcerpc_server_id = PyImport_ImportModule("samba.dcerpc.server_id");
	if (dep_samba_dcerpc_server_id == NULL)
		return NULL;

	dep_talloc = PyImport_ImportModule("talloc");
	if (dep_talloc == NULL)
		return NULL;

	server_id_Type = (PyTypeObject *)PyObject_GetAttrString(dep_samba_dcerpc_server_id, "server_id");
	if (server_id_Type == NULL)
		return NULL;

	file_id_Type = (PyTypeObject *)PyObject_GetAttrString(dep_samba_dcerpc_file_id, "file_id");
	if (file_id_Type == NULL)
		return NULL;

	BaseObject_Type = (PyTypeObject *)PyObject_GetAttrString(dep_talloc, "BaseObject");
	if (BaseObject_Type == NULL)
		return NULL;

	notify_entry_Type.tp_base = BaseObject_Type;
	notify_entry_Type.tp_basicsize = pytalloc_BaseObject_size();

	notify_entry_array_Type.tp_base = BaseObject_Type;
	notify_entry_array_Type.tp_basicsize = pytalloc_BaseObject_size();

	notify_db_entry_Type.tp_base = BaseObject_Type;
	notify_db_entry_Type.tp_basicsize = pytalloc_BaseObject_size();

	notify_depth_Type.tp_base = BaseObject_Type;
	notify_depth_Type.tp_basicsize = pytalloc_BaseObject_size();

	notify_array_Type.tp_base = BaseObject_Type;
	notify_array_Type.tp_basicsize = pytalloc_BaseObject_size();

	notify_event_Type.tp_base = BaseObject_Type;
	notify_event_Type.tp_basicsize = pytalloc_BaseObject_size();

	notify_remote_event_Type.tp_base = BaseObject_Type;
	notify_remote_event_Type.tp_basicsize = pytalloc_BaseObject_size();

	FILE_NOTIFY_INFORMATION_Type.tp_base = BaseObject_Type;
	FILE_NOTIFY_INFORMATION_Type.tp_basicsize = pytalloc_BaseObject_size();

	if (PyType_Ready(&notify_entry_Type) < 0)
		return NULL;
	if (PyType_Ready(&notify_entry_array_Type) < 0)
		return NULL;
	if (PyType_Ready(&notify_db_entry_Type) < 0)
		return NULL;
	if (PyType_Ready(&notify_depth_Type) < 0)
		return NULL;
	if (PyType_Ready(&notify_array_Type) < 0)
		return NULL;
	if (PyType_Ready(&notify_event_Type) < 0)
		return NULL;
	if (PyType_Ready(&notify_remote_event_Type) < 0)
		return NULL;
	if (PyType_Ready(&FILE_NOTIFY_INFORMATION_Type) < 0)
		return NULL;
#ifdef PY_ENTRY_PATCH
	PY_ENTRY_PATCH(&notify_entry_Type);
#endif
#ifdef PY_ENTRY_ARRAY_PATCH
	PY_ENTRY_ARRAY_PATCH(&notify_entry_array_Type);
#endif
#ifdef PY_DB_ENTRY_PATCH
	PY_DB_ENTRY_PATCH(&notify_db_entry_Type);
#endif
#ifdef PY_DEPTH_PATCH
	PY_DEPTH_PATCH(&notify_depth_Type);
#endif
#ifdef PY_ARRAY_PATCH
	PY_ARRAY_PATCH(&notify_array_Type);
#endif
#ifdef PY_EVENT_PATCH
	PY_EVENT_PATCH(&notify_event_Type);
#endif
#ifdef PY_REMOTE_EVENT_PATCH
	PY_REMOTE_EVENT_PATCH(&notify_remote_event_Type);
#endif
#ifdef PY_FILE_NOTIFY_INFORMATION_PATCH
	PY_FILE_NOTIFY_INFORMATION_PATCH(&FILE_NOTIFY_INFORMATION_Type);
#endif

	m = PyModule_Create(&moduledef);
	if (m == NULL)
		return NULL;

	PyModule_AddObject(m, "FILE_ACTION_ADDED", ndr_PyLong_FromUnsignedLongLong((uint32_t)FILE_ACTION_ADDED));
	PyModule_AddObject(m, "FILE_ACTION_REMOVED", ndr_PyLong_FromUnsignedLongLong((uint32_t)FILE_ACTION_REMOVED));
	PyModule_AddObject(m, "FILE_ACTION_MODIFIED", ndr_PyLong_FromUnsignedLongLong((uint32_t)FILE_ACTION_MODIFIED));
	PyModule_AddObject(m, "FILE_ACTION_RENAMED_OLD_NAME", ndr_PyLong_FromUnsignedLongLong((uint32_t)FILE_ACTION_RENAMED_OLD_NAME));
	PyModule_AddObject(m, "FILE_ACTION_RENAMED_NEW_NAME", ndr_PyLong_FromUnsignedLongLong((uint32_t)FILE_ACTION_RENAMED_NEW_NAME));
	PyModule_AddObject(m, "FILE_ACTION_ADDED_STREAM", ndr_PyLong_FromUnsignedLongLong((uint32_t)FILE_ACTION_ADDED_STREAM));
	PyModule_AddObject(m, "FILE_ACTION_REMOVED_STREAM", ndr_PyLong_FromUnsignedLongLong((uint32_t)FILE_ACTION_REMOVED_STREAM));
	PyModule_AddObject(m, "FILE_ACTION_MODIFIED_STREAM", ndr_PyLong_FromUnsignedLongLong((uint32_t)FILE_ACTION_MODIFIED_STREAM));
	Py_INCREF((PyObject *)(void *)&notify_entry_Type);
	PyModule_AddObject(m, "entry", (PyObject *)(void *)&notify_entry_Type);
	Py_INCREF((PyObject *)(void *)&notify_entry_array_Type);
	PyModule_AddObject(m, "entry_array", (PyObject *)(void *)&notify_entry_array_Type);
	Py_INCREF((PyObject *)(void *)&notify_db_entry_Type);
	PyModule_AddObject(m, "db_entry", (PyObject *)(void *)&notify_db_entry_Type);
	Py_INCREF((PyObject *)(void *)&notify_depth_Type);
	PyModule_AddObject(m, "depth", (PyObject *)(void *)&notify_depth_Type);
	Py_INCREF((PyObject *)(void *)&notify_array_Type);
	PyModule_AddObject(m, "array", (PyObject *)(void *)&notify_array_Type);
	Py_INCREF((PyObject *)(void *)&notify_event_Type);
	PyModule_AddObject(m, "event", (PyObject *)(void *)&notify_event_Type);
	Py_INCREF((PyObject *)(void *)&notify_remote_event_Type);
	PyModule_AddObject(m, "remote_event", (PyObject *)(void *)&notify_remote_event_Type);
	Py_INCREF((PyObject *)(void *)&FILE_NOTIFY_INFORMATION_Type);
	PyModule_AddObject(m, "FILE_NOTIFY_INFORMATION", (PyObject *)(void *)&FILE_NOTIFY_INFORMATION_Type);
#ifdef PY_MOD_NOTIFY_PATCH
	PY_MOD_NOTIFY_PATCH(m);
#endif
	return m;

}
